/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using MPLAB?Code Configurator

  @Description:
    This header file provides implementations for pin APIs for all pins selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB?Code Configurator - v2.25.2
        Device            :  PIC16F1619
        Version           :  1.01
    The generated drivers are tested against the following:
        Compiler          :  XC8 v1.34
        MPLAB             :  MPLAB X v2.35 or v3.00
 */

/*
Copyright (c) 2013 - 2015 released Microchip Technology Inc.  All rights reserved.

Microchip licenses to you the right to use, modify, copy and distribute
Software only when embedded on a Microchip microcontroller or digital signal
controller that is integrated into your product or third party product
(pursuant to the sublicense terms in the accompanying license agreement).

You should refer to the license agreement accompanying this Software for
additional information regarding your rights and obligations.

SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
(INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
 */

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set ZCD1IN aliases
#define ZCD1IN_TRIS               TRISA2
#define ZCD1IN_LAT                LATA2
#define ZCD1IN_PORT               RA2
#define ZCD1IN_ANS                ANSA2
#define ZCD1IN_SetHigh()    do { LATA2 = 1; } while(0)
#define ZCD1IN_SetLow()   do { LATA2 = 0; } while(0)
#define ZCD1IN_Toggle()   do { LATA2 = ~LATA2; } while(0)
#define ZCD1IN_GetValue()         RA2
#define ZCD1IN_SetDigitalInput()    do { TRISA2 = 1; } while(0)
#define ZCD1IN_SetDigitalOutput()   do { TRISA2 = 0; } while(0)

#define ZCD1IN_SetAnalogMode()   do { ANSA2 = 1; } while(0)
#define ZCD1IN_SetDigitalMode()   do { ANSA2 = 0; } while(0)
// get/set ZCD1OUT aliases
#define ZCD1OUT_TRIS               TRISA5
#define ZCD1OUT_LAT                LATA5
#define ZCD1OUT_PORT               RA5
#define ZCD1OUT_SetHigh()    do { LATA5 = 1; } while(0)
#define ZCD1OUT_SetLow()   do { LATA5 = 0; } while(0)
#define ZCD1OUT_Toggle()   do { LATA5 = ~LATA5; } while(0)
#define ZCD1OUT_GetValue()         RA5
#define ZCD1OUT_SetDigitalInput()    do { TRISA5 = 1; } while(0)
#define ZCD1OUT_SetDigitalOutput()   do { TRISA5 = 0; } while(0)

// get/set PWM3OUT aliases
#define PWM3OUT_TRIS               TRISC3
#define PWM3OUT_LAT                LATC3
#define PWM3OUT_PORT               RC3
#define PWM3OUT_ANS                ANSC3
#define PWM3OUT_SetHigh()    do { LATC3 = 1; } while(0)
#define PWM3OUT_SetLow()   do { LATC3 = 0; } while(0)
#define PWM3OUT_Toggle()   do { LATC3 = ~LATC3; } while(0)
#define PWM3OUT_GetValue()         RC3
#define PWM3OUT_SetDigitalInput()    do { TRISC3 = 1; } while(0)
#define PWM3OUT_SetDigitalOutput()   do { TRISC3 = 0; } while(0)

#define PWM3OUT_SetAnalogMode()   do { ANSC3 = 1; } while(0)
#define PWM3OUT_SetDigitalMode()   do { ANSC3 = 0; } while(0)
// get/set CLC1OUT aliases
#define CLC1OUT_TRIS               TRISC5
#define CLC1OUT_LAT                LATC5
#define CLC1OUT_PORT               RC5
#define CLC1OUT_WPU                WPUC5
#define CLC1OUT_SetHigh()    do { LATC5 = 1; } while(0)
#define CLC1OUT_SetLow()   do { LATC5 = 0; } while(0)
#define CLC1OUT_Toggle()   do { LATC5 = ~LATC5; } while(0)
#define CLC1OUT_GetValue()         RC5
#define CLC1OUT_SetDigitalInput()    do { TRISC5 = 1; } while(0)
#define CLC1OUT_SetDigitalOutput()   do { TRISC5 = 0; } while(0)

#define CLC1OUT_SetPullup()    do { WPUC5 = 1; } while(0)
#define CLC1OUT_ResetPullup()   do { WPUC5 = 0; } while(0)

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    GPIO and peripheral I/O initialization
 * @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize(void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);

#endif // PIN_MANAGER_H
/**
 End of File
 */